set verify off
set echo off
set long 10000000
set linesize 32767
set pages 0
set feedback off


col "CODIGO_FONTE" format a50000
col "indexes" format a50000
col "triggers" format a50000


accept obj 		prompt "Objeto: "




select 
	dbms_metadata.get_ddl(replace(object_type, ' ', '_'), object_name, owner) || '/' codigo_fonte	
from
	dba_objects
where
	object_name = upper('&obj')
/


select 
	dbms_metadata.get_ddl('INDEX', index_name, owner) || '/' indexes
from 
	dba_indexes
where
	table_name = upper('&obj');
	
	
	
	
select 
	dbms_metadata.get_ddl('TRIGGER', trigger_name, owner) || '/' triggers
from 
	dba_triggers
where
	table_name = upper('&obj');
	
	
	
	
	
select (case 
	when grantable = 'NO' then
		'GRANT '||privilege||' on '||owner||'."'||table_name||'" to "'||grantee||'";' 
	else
		'GRANT '||privilege||' on '||owner||'."'||table_name||'" to "'||grantee||'" with grant option;' end ) commamd 
FROM dba_tab_privs 
WHERE (table_name = upper('&obj')) and (grantee NOT LIKE 'ACB%')
ORDER BY grantee
/



SELECT 'CREATE PUBLIC SYNONYM '||table_name||' for '||table_owner||'."'||table_name||'";' 
FROM dba_synonyms 
WHERE table_name = upper('&obj')
and owner = 'PUBLIC'
/

SELECT 'CREATE SYNONYM '||owner||'.'||table_name||' for '||table_owner||'."'||table_name||'";' 
FROM dba_synonyms 
WHERE table_name = upper('&obj')
and owner != 'PUBLIC'
/



undef obj 


set verify on
set feedback on