set verify off
set echo off
set long 10000000
set linesize 32767
set pages 0
set feedback off

col CODIGO_FONTE format a50000


accept owner 	prompt "Owner: "
accept dir 		prompt 'Diretorio de spool: '


spool "&dir\backup_sequence_&owner..sql"

prompt
prompt spool "&dir\backup_sequence_&owner..log"
prompt
prompt set echo on
prompt

-- Gerando DDL da criao da sequence

select
   dbms_metadata.get_ddl('SEQUENCE', sequence_name, sequence_owner) || '/'
from
   dba_sequences
where
   sequence_owner like upper('&owner%')
/


prompt
prompt
prompt
prompt


-- Aplicando grants para roles e chaves de sistemas

select (case 
	when grantable = 'NO' then
		'GRANT '||privilege||' on '||owner||'."'||table_name||'" to "'||grantee||'";' 
	else
		'GRANT '||privilege||' on '||owner||'."'||table_name||'" to "'||grantee||'" with grant option;' end ) commamd 
FROM dba_tab_privs 
WHERE (owner = upper('&owner'))
and table_name in (select sequence_name from dba_sequences)
ORDER BY grantee
/


prompt
prompt
prompt
prompt




-- Criao dos sinnimos pblicos

SELECT 'CREATE PUBLIC SYNONYM '||table_name||' for '||table_owner||'."'||table_name||'";' 
FROM dba_synonyms 
WHERE table_owner = upper('&owner')
and table_name in (select sequence_name from dba_sequences where sequence_owner = upper('&owner'))
and owner = 'PUBLIC'
/


prompt
prompt



-- Criao dos sinnimos privados

SELECT 'CREATE SYNONYM '||owner||'.'||table_name||' for '||table_owner||'."'||table_name||'";' 
FROM dba_synonyms 
WHERE owner = upper('&owner')
and table_name in (select sequence_name from dba_sequences where sequence_owner = upper('&owner'))
/


prompt
prompt set echo off
prompt
prompt spool off
prompt

spool off


undef owner

set verify on
set feedback on
set head on